osg::RenderBuffer Class Reference

`#include <FrameBufferObject>`

Inheritance diagram for osg::RenderBuffer:

## Public Member Functions

| RenderBuffer ()
| RenderBuffer (int width, int height, GLenum internalFormat, int samples=0, int colorSamples=0)
| RenderBuffer (const RenderBuffer &copy, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Object (osg, RenderBuffer)
int | getWidth () const
int | getHeight () const
void | setWidth (int w)
void | setHeight (int h)
void | setSize (int w, int h)
GLenum | getInternalFormat () const
void | setInternalFormat (GLenum format)
int | getSamples () const
int | getColorSamples () const
void | setSamples (int samples)
void | setColorSamples (int colorSamples)
GLuint | getObjectID (unsigned int contextID, const GLExtensions *ext) const
int | compare (const RenderBuffer &rb) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
virtual const char * | className () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Static Public Member Functions

static int | getMaxSamples (unsigned int contextID, const GLExtensions *ext)
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Protected Member Functions

virtual | ~RenderBuffer ()
RenderBuffer & | operator= (const RenderBuffer &)
void | dirtyAll () const
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Constructor & Destructor Documentation

## RenderBuffer() [1/3]

osg::RenderBuffer::RenderBuffer | ( |  | ) |

Referenced by compare(), getObjectID(), META_Object(), operator=(), and RenderBuffer().

## RenderBuffer() [2/3]

osg::RenderBuffer::RenderBuffer | ( | int | width,
|  | int | height,
|  | GLenum | internalFormat,
|  | int | samples = 0,
|  | int | colorSamples = 0 )

## RenderBuffer() [3/3]

osg::RenderBuffer::RenderBuffer | ( | const RenderBuffer & | copy,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

References RenderBuffer(), and osg::CopyOp::SHALLOW_COPY.

## ~RenderBuffer()

virtual osg::RenderBuffer::~RenderBuffer | ( |  | ) |

protected virtual

## Member Function Documentation

## compare()

int osg::RenderBuffer::compare | ( | const RenderBuffer & | rb | ) | const

inline

References RenderBuffer().

Referenced by getObjectID().

## dirtyAll()

void osg::RenderBuffer::dirtyAll | ( |  | ) | const

inline protected

Referenced by setColorSamples(), setHeight(), setInternalFormat(), setSamples(), setSize(), and setWidth().

## getColorSamples()

int osg::RenderBuffer::getColorSamples | ( |  | ) | const

inline

Referenced by META_Object().

## getHeight()

int osg::RenderBuffer::getHeight | ( |  | ) | const

inline

Referenced by META_Object().

## getInternalFormat()

GLenum osg::RenderBuffer::getInternalFormat | ( |  | ) | const

inline

Referenced by META_Object().

## getMaxSamples()

int osg::RenderBuffer::getMaxSamples | ( | unsigned int | contextID,
|  | const GLExtensions * | ext )

static

## getObjectID()

GLuint osg::RenderBuffer::getObjectID | ( | unsigned int | contextID,
|  | const GLExtensions * | ext ) const

References compare(), and RenderBuffer().

## getSamples()

int osg::RenderBuffer::getSamples | ( |  | ) | const

inline

Referenced by META_Object().

## getWidth()

int osg::RenderBuffer::getWidth | ( |  | ) | const

inline

Referenced by META_Object().

## META_Object()

osg::RenderBuffer::META_Object | ( | osg | ,
|  | RenderBuffer | )

References getColorSamples(), getHeight(), getInternalFormat(), getSamples(), getWidth(), RenderBuffer(), setColorSamples(), setHeight(), setInternalFormat(), setSamples(), setSize(), and setWidth().

## operator=()

RenderBuffer & osg::RenderBuffer::operator= | ( | const RenderBuffer & |  | ) |

inline protected

References RenderBuffer().

## releaseGLObjects()

virtual void osg::RenderBuffer::releaseGLObjects | ( | osg::State * | = 0 | ) | const

virtual

If State is non-zero, this function releases any associated OpenGL objects for the specified graphics context. Otherwise, releases OpenGL objexts for all graphics contexts.

Reimplemented from osg::Object.

## resizeGLObjectBuffers()

virtual void osg::RenderBuffer::resizeGLObjectBuffers | ( | unsigned int | maxSize | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::Object.

## setColorSamples()

void osg::RenderBuffer::setColorSamples | ( | int | colorSamples | ) |

inline

References dirtyAll().

Referenced by META_Object().

## setHeight()

void osg::RenderBuffer::setHeight | ( | int | h | ) |

inline

References dirtyAll().

Referenced by META_Object().

## setInternalFormat()

void osg::RenderBuffer::setInternalFormat | ( | GLenum | format | ) |

inline

References dirtyAll().

Referenced by META_Object().

## setSamples()

void osg::RenderBuffer::setSamples | ( | int | samples | ) |

inline

References dirtyAll().

Referenced by META_Object().

## setSize()

void osg::RenderBuffer::setSize | ( | int | w,
|  | int | h )

inline

References dirtyAll().

Referenced by META_Object().

## setWidth()

void osg::RenderBuffer::setWidth | ( | int | w | ) |

inline

References dirtyAll().

Referenced by META_Object().

The documentation for this class was generated from the following file:

- FrameBufferObject